io = require "socket.io"
EventEmitter = require("events").EventEmitter

dk.plugin "websockets", ["assets"], ->
  socket = null
  shouldRun = true
  emitter = new EventEmitter()

  emitter.config = (opts) ->
    unless opts.run == undefined
      shouldRun = opts.run

  emitter.run = ->
    return unless shouldRun
    socket = io.listen dk.server
    socket.on 'connection', (client) ->
      emitter.emit 'connection', client
      client.on 'message', (msg)->
        emitter.emit 'message', client, msg
      client.on 'disconnect', () ->
        emitter.emit 'disconnect', client

    dk.assets.package "/socket.io/socket.io.js", "#{__dirname}/../node_modules/socket.io/support/socket.io-client/socket.io.js", false
    dk.assets.package "/js/dk-websockets.js", "#{__dirname}/../public/js/dk-websockets.coffee"

  return emitter
